{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O+,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
Unit DMAGRAPH;
Interface
Uses Dos;
const grange:integer=-1;
Type rm=array [0..65534] of byte;
Type EdgeArr=array [0..200] of integer;
     EdgeSrc=array [0..200] of record
                               x,y:integer;
                               end;

Type TPaletteTypeItem=Record
                      colnum,r,g,b:Byte;
                      End;
     TPaletteType=Array [1..16] of TPaletteTypeItem;

Type TBlock=Array [1..8,1..8] of Byte;
     TChunk=array [1..75] of byte;
     Bitbyte=array [1..8] of boolean;
     TVT=Array [1..8] of bitbyte;
     TYPrecalculatedTable=array [0..200] of word;
     poz=Record
         x,y:Word;
         End;
     texture=record
     as,df:Word;
     d:Array [0..60,0..60] of Byte;
     end;
     k=^rm;
     T3DCoords=Record
               x,y,z:real;
               End;
     tcol=record
          r,g,b:Byte;
          End;
     tpalette=array [0..255] of tcol;
Const rainbow:TPaletteType=
(
(colnum:1;R:0;G:0;B:0),
(colnum:32;R:63;G:0;B:63),
(colnum:64;R:63;G:0;B:0),
(colnum:96;R:63;G:63;B:0),
(colnum:128;R:0;G:63;B:0),
(colnum:160;R:0;G:63;B:63),
(colnum:192;R:0;G:0;B:63),
(colnum:224;R:32;G:32;B:32),
(colnum:255;R:64;G:64;B:64),
(colnum:0;R:0;G:0;B:0),
(colnum:0;R:0;G:0;B:0),
(colnum:0;R:0;G:0;B:0),
(colnum:0;R:0;G:0;B:0),
(colnum:0;R:0;G:0;B:0),
(colnum:0;R:0;G:0;B:0),
(colnum:0;R:0;G:0;B:0)

);

Var
tiptr:word;
SA:Byte;
regs:registers;
Calcy:TYPrecalculatedTable;
p:rm absolute $A000:$0000;
p1:k;
Mode:integer;
Procedure clr;
Function Keypressed:boolean;
Procedure GeneratePalette(Var z:Tpalette;a:TpaletteType);
Function Readkey:char;
Procedure Purg;
Procedure PAuse;
Procedure LoadTexture(FileName:String;Var f:Texture);
Function  Vpoint (x,y:Word):Byte;
Procedure Vdraw (x,y:word;col:Byte);
Procedure WDraw (x,y:Word;Col:Byte);
Function Wpoint(x,y:Word):Byte;
Procedure Winc_(x,y:word;count:byte);
Procedure cls;
Procedure Xdraw (x,y:Word;col:Byte);
Procedure Line (x1,y1,x2,y2:longint;col:Byte);
Procedure Sline(x,y,x1,y1:integer;col:Byte);
Procedure Gotoxy(x,y:byte);
Procedure LoadBmp(Name:String);
Procedure jline(x,y,x1,y1:integer;col:Byte);
Procedure cbuff(x,y,xi,yi:integer);
Procedure ChMod (I:Integer);
Procedure FillScr0(col:Byte);
Procedure FillScr1(col:Byte);
Procedure FillScr(col:Byte);
Procedure CopyAll;
Procedure Loadvpg(filename:string);
Procedure Adraw (x,y:real;col,min:byte);
Procedure VBrick (x,y,w,h,col:Word);
Procedure wWrite (x,y:Word;s:String;col:Byte);
Procedure vWrite (x,y:Word;s:String;col:Byte);
Procedure Dmt (x,y,x1,y1,x2,y2,x3,y3:integer;d:texture);
Procedure fDmt (x,y,x1,y1,x2,y2,x3,y3:integer;Var d:texture);
Procedure D3DT (x,y,x1,y1,x2,y2,x3,y3:integer;Var d:texture);
Procedure LoadTexture64 (fname:String;var f:Texture;range:Byte);
Procedure TR(v:T3dCoords;Var x,y:integer);
Procedure fTR(v:T3dCoords;Var x,y:integer);
Procedure v640TR(v:T3dCoords;Var x,y:integer);
{Procedure Dmtn(x,y,x1,y1,x2,y2,x3,y3:integer;Var d:texture);}
Procedure Filled4k(x,y,x1,y1,x2,y2,x3,y3:integer;var d:texture);
Procedure Fill4k(x,y,x1,y1:integer;col:byte);
Procedure Blur0;
Procedure rTR(v:T3dCoords;Var x,y:real);
Procedure SetVscale(a:integer);
Procedure SetHscale(a:integer);
Procedure Getpalette(var a:tpalette);
Procedure initpalette(a:tpalette);
Procedure swi(Var a,b:integer);
implementation
var vscale,hscale:integer;
Procedure clr;
 Var i:Word;
 Begin
 For i:=1 to 64000 do p[i]:=0;
 End;
Function Keypressed:Boolean;
 var a:Byte;
 Begin
 Asm
 mov ah,11
 int 33
 mov a,al
 End;
 Keypressed:=(a<>0);
 End;
Function Readkey:Char;
 Var c:Char;
 begin
 asm
 mov ah,7
 int 33
 mov c,al
 End;
 Readkey:=c;
 End;

Procedure Purg;
 Var c:Char;
 Begin
 while keypressed do c:=readkey;
 End;
Procedure Pause;
 Begin
 Repeat until keypressed;
 purg;
 End;
Procedure Swi(var a,b:integer);
 Var c:integer;
 Begin
 c:=a;
 a:=b;
 b:=c;
 End;
Procedure LoadTexture(FileName:String;Var f:Texture);
  Var g:Text;
  i,j:Byte;
  su:String;
  Begin
  Assign(g,Filename);
  Reset(g);
  For i:=1 to 60 do
   Begin
    readln(g,su);
    For j:=1 to 60 do f.d[j,i]:=Ord(su[j])+grange+1;
   End;
  Close(g);
  f.as:=58;
  f.df:=60;
  End;
Procedure Loadtexture64(fname:String;var f:Texture;Range:Byte);
 Var c:Char;
     b:Boolean;
     i,j:Word;
     As:Tpalette;
     t:Text;
 Begin
 grange:=range;
 Assign(t,fname);
 Reset(t);
 Read(t,c);
 b:=(c='B');
 Read(t,c);
 b:=b and (c='M');
 If not b then
  Begin
  Close(t);
  loadtexture(fname,f);
  exit;
  End;
 For i:=1 to 52 do Read(t,c);
 For i:=1 to 64 do
  Begin
  Read(t,c);
  as[i].b:=(Ord(c)) div 4;
  Read(t,c);
  as[i].g:=(Ord(c)) div 4;
  Read(t,c);
  as[i].r:=(Ord(c)) div 4;
  Read(t,c);
  End;
 For i:=1 to 64 do
  Begin
  Port[$3c8]:=i+range;
  Port[$3c9]:=as[i].r;
  Port[$3c9]:=as[i].g;
  Port[$3c9]:=as[i].b;
  End;
 For i:=59 downto 0 do
  For j:=1 to 60 do
   Begin
   Read(t,c);
   f.d[j,i]:=ord(c)+range+1;
   End;
 f.as:=58;
 f.df:=60;
 Close(t);
 grange:=-1;
 End;

Procedure Fillscr(col:Byte);
 Var i:word;
 Begin
 For i:=1 to 64000 do p[i]:=col;
 End;

Function Vpoint (x,y:Word):Byte;
 Begin
 If y<200 then
 vpoint:=p[y*320+x];
 End;

Function wpoint (x,y:Word):Byte;
 Begin
 If (y<200) and (x<320) then
 wpoint:=p1^[y*320+x] else wpoint:=0;
 End;
Procedure Winc_(x,y:word;count:byte);
 Begin
 If (y<200) and (x<320) then
  inc(p1^[y*320+x],count);
 End;
Procedure Vdraw (x,y:word;col:Byte);
 Begin
 If (y<200) and (x<320) then
 p[calcy[y]+x]:=col;
 End;
Procedure Wdraw (x,y:word;col:Byte);
 Begin
 If (y<200) and (x<320) then
 p1^[calcy[y]+x]:=col;
 End;
Procedure jdraw (x,y:word;col:Byte);
 Var c:longint;
 Begin
 c:=(longint(y)*640+x) div 8;
 If (y<480) and (x<640) then
 p1^[c]:=p1^[c] or (128 shr (longint(y)*640+x mod 8));
 End;



Procedure Adraw (x,y:real;col,min:byte);
 var a:byte;
     x1,y1:integer;
     vk,wk:real;
 Begin
 a:=col-min;
 vk:=frac(x);
 wk:=frac(y);
 x1:=trunc(x);
 y1:=trunc(y);
 wdraw(x1,y1,Round((1-vk)*(1-wk)*a+min));
 wdraw(x1+1,y1,Round(vk*(1-wk))*a+min);
 wdraw(x1,y1+1,round((1-vk)*wk*a+min));
 wdraw(x1+1,y1+1,round(vk*wk*a+min));
 End;

Procedure Xdraw (x,y:Word;col:Byte);
 Var y1:Word;
 Mask:Byte;
 iz:Word;
 Begin
 If Mode=$13 then
  Begin
  Vdraw (x,y,col);
  Exit;
  End;
 y1:=y mod 200;
 iz:=y1*640+x;
 mask:=15;
 If Not odd(x) then mask:=mask shl 4;
 If y>=200 then p1^[iz]:=p1^[iz] and mask
          else p[iz]:=p[iz] and mask;
 Mask:=Col;
 If odd(x) then mask:=mask shl 4;
 If y>=200 then p1^[iz]:=p1^[iz] or mask
          else p[iz]:=p[iz] or mask;
 End;
{Procedure Line (x,y,x1,y1:longint;col:Byte);
 Var i,j:longint;
     k:Integer;
     x2,y2,x3,y3:Word;
     flg,t1,t2:Boolean;
 Begin
 t1:=FALSE;
 t2:=FALSE;
 x2:=x;
 x3:=x1;
 y2:=y;
 y3:=y1;
 If x>x1 then t1:=TRUE;
 If y>y1 then t2:=TRUE;
 If t1 then
  Begin
  x2:=x1;
  x3:=x;
  End;
 If t2 then
  Begin
  y2:=y1;
  y3:=y;
  End;
 Vdraw (x1,y1,col);
 VDraw (x,y,col);
 If (x1=x) and t2 then for j:=y1 downto y do Vdraw (x,j,col);
 If (x1=x) and Not t2 then for j:=y to y1 do Vdraw (x,j,col);
 If (y1=y) and t1 then for j:=x1 downto x do Vdraw (j,y,col);
 If (y1=y) and Not t1 then for j:=x to x1 do Vdraw (j,y,col);
 If (x1<>x) and (y1<>y) then If not t1  then For i:=x2 to x3 do
  Begin
  If not t2 then vDraw (i,y2+Round(((i-x2)/(x3-x2))*(y3-y2)),col)
            else vdraw (i,y-Round(((i-x2)/(x3-x2))*(y3-y2)),col);
  End
            else for i:=x3 downto x2 do
  Begin
  If not t2 then vDraw (i,y2+Round(((x3-i)/(x3-x2))*(y3-y2)),col)
            else vdraw (i,y-Round(((x3-i)/(x3-x2))*(y3-y2)),col);
  End;

 End;}
Function Min(a,b:Integer):Integer;
 Begin
 if a<b then min:=a
 else min:=b;
 End;
Function Max(a,b:Integer):Integer;
 Begin
 if a>b then max:=a
 else max:=b;
 End;


Procedure Line(x1,y1,x2,y2:longint;col:byte);
 var x,y,xi,yi:longint;
     i,s:longint;
 begin
 s:=max(abs(x1-x2)+1,abs(y1-y2)+1);
 xi:=round((x2-x1)/s * 65536);
 yi:=round((y2-y1)/s * 65536);
 x:=x1*65536;
 y:=y1*65536;
 for i:=0 to s do
  begin
  vdraw(x shr 16,y shr 16,col);
  x:=x+xi;
  y:=y+yi;
  end;

 End;


Procedure Fill4k(x,y,x1,y1:integer;col:Byte);
 Var i,j,k,vd:longint;
 Begin
 if (x=x1) and (y=y1) then wdraw(x,y,col);
 if x>x1 then swi(x,x1);
 if y>y1 then swi(y,y1);
 vd:=x1-x;
 vd:=319-vd;
 if (y>199) or (x>320) then exit;
 If (x<1) or (y<1) then exit;
 i:=longint(y)*320+longint(x);
 For j:=0 to y1-y do
  Begin
  For k:=0 to x1-x do
   Begin
   p1^[i]:=col;
   inc(i);
   End;
  if i>64000 then exit;
  i:=i+vd;
  End;
 End;
Procedure sLine (x,y,x1,y1:integer;col:Byte);
 Var i:integer;
     r,ry:real;
 Begin
 If x1=x then
  Begin
  For i:=min(y,y1) to max(y,y1) do wdraw(x,i,col);
  Exit;
  End;
 if x>x1 then
  Begin
  swi(x,x1);
  swi(y,y1);
  End;
 r:=(y1-y)/(x1-x);
 ry:=y;
 For i:=x to x1 do
  Begin
  wdraw(i,round(ry),col);
  ry:=ry+r;
  End;

 End;
Procedure jLine (x,y,x1,y1:integer;col:Byte);
 Var i:integer;
     r,ry:real;
 Begin
 If x1=x then
  Begin
  For i:=min(y,y1) to max(y,y1) do jdraw(x,i,col);
  Exit;
  End;
 if x>x1 then
  Begin
  swi(x,x1);
  swi(y,y1);
  End;
 r:=(y1-y)/(x1-x);
 ry:=y;
 For i:=x to x1 do
  Begin
  jdraw(i,round(ry),col);
  ry:=ry+r;
  End;

 End;


Procedure CopyAll;
 Var sg,ofs:Word;
 Begin
{ for sg:=1 to 64000 do p[sg]:=p1^[sg];}
 sg:=Longint(p1) shr 16;
 ofs:=longint(p1) and $0ffff;
 Asm
 push ds
 push es
 push si
 push di
 mov ax,sg
 mov ds,ax
 mov ax,0a000h
 mov es,ax
 mov si,ofs
 xor di,di
 cld
 mov cx,32000
 rep movsw
 pop di
 pop si
 pop es
 pop ds
 End;
 End;
Procedure FillScr0(Col:Byte);
 Var sg,ofs:Word;
 Begin
 sg:=Longint(p1) shr 16;
 ofs:=longint(p1) and $0ffff;
 Asm
 push es
 push di
 mov ax,sg
 mov es,ax
 mov ax,ofs
 mov di,ax
 mov al,col
 mov ah,al
 cld
 mov cx,32000
 rep stosw
 pop di
 pop es
 End;
 End;
Procedure blur0;
 Var sg,ofs:Word;
 Begin
 sg:=Longint(p1) shr 16;
 ofs:=(longint(p1) and $0ffff);
 Asm
 push es
 push di
 mov ax,sg
 mov es,ax
 mov ax,ofs
 mov di,ax
 xor ax,ax
 xor bh,bh
 cld
 mov cx,160
 rep stosw
 mov cx,63360
@lll:
 xor ax,ax
 mov bl,[es:di-320]
 add ax,bx
 mov bl,[es:di+320]
 add ax,bx
 mov bl,[es:di-1]
 add ax,bx
 mov bl,[es:di+1]
 add ax,bx
 shr ax,2
 stosb
 loop @lll;
 mov cx,160
 xor ax,ax
 rep stosw

 End;
 end;
Procedure FillScr1(Col:Byte);
 Var sg,ofs:Word;
 Begin
 sg:=Longint(p1) shr 16;
 ofs:=longint(p1) and $0ffff;
 Asm
 push es
 push di
 mov ax,sg
 mov es,ax
 mov ax,ofs
 mov di,ax
 add di,32000
 xor ax,ax
 cld
 mov cx,16000
 rep stosw
 pop di
 pop es
 End;
 End;

Procedure ChMod (i:integer);
 Var
 modeb:Byte;
 Begin
 mode:=i;
 If i=3 then
  Begin
  regs.al:=03;
  Intr($10,regs);
  Exit;
  End;
 regs.ax:=i;
 Intr($10,regs);
 End;
Procedure cbuff(x,y,xi,yi:integer);
 Var i,j:integer;
 begin
 for i:=x to x+xi-1 do
  for j:=y to y+yi-1 do vdraw(i,j,wpoint(i,j));
 End;
Procedure VBrick (x,y,w,h,col:Word);
 Var i,j,k:Word;
 Begin
 For j:=1 to h do
  Begin
  k:=(j+y)*320;
  For i:=1 to w do p[k+x+i]:=col;
  End;
 end;
Procedure cls;
 Begin
 chmod(3);
 End;
Procedure wWrite (x,y:Word;s:String;col:Byte);
 Var c:array [1..2048] of byte absolute $f000:$fa6e;
 i,j,k:Word;
 sh,mask:Byte;
 Begin
 For k:=1 to length(s) do
  Begin
  For j:=1 to 8 do
   Begin
   sh:=c[Ord(s[k])*8+j];
   For i:=1 to 8 do
    Begin
    Mask:=1 shl (8-i);
    If (sh and mask)<>0 then wdraw(i+x-1,j+y-1,col);
    End;
   End;
  Inc(x,9);
  End;
 End;
Procedure vWrite (x,y:Word;s:String;col:Byte);
 Var c:array [1..2048] of byte absolute $f000:$fa6e;
 i,j,k:Word;
 sh,mask:Byte;
 Begin
 For k:=1 to length(s) do
  Begin
  For j:=1 to 8 do
   Begin
   sh:=c[Ord(s[k])*8+j];
   For i:=1 to 8 do
    Begin
    Mask:=1 shl (8-i);
    If (sh and mask)<>0 then vdraw(i+x-1,j+y-1,col);
    End;
   End;
  Inc(x,8);
  End;
 End;

Procedure DMT(x,y,x1,y1,x2,y2,x3,y3:Integer;d:Texture);
 var le,re,ue,de:EdgeArr;
     les,res,ues,des:Edgesrc;
     pt:word;
     i,j:integer;
     k,ki,kx,kxi,ky,kyi:longint;
 Procedure calcedge(x,x2,y,y2,ix,iy:integer;var e:Edgearr;var es:Edgesrc;sckxi,sckyi:boolean);
  Var i:integer;
      k,ki,kx,kxi,ky,kyi:longint;
  Begin

  if y2<y then
   Begin
   swi(y,y2);
   swi(x,x2);
   End;
  if y2-y=0 then inc(y2);
  k:=longint(x) shl 16;
  kx:=longint(ix) shl 16;
  ky:=longint(iy) shl 16;
  if sckxi then kxi:=round(60/(y2-y)*65536)
   else kxi:=0;
  if sckyi then kyi:=round(60/(y2-y)*65536)
   else kyi:=0;
  ki:=round((x2-x)/(y2-y)*65536);
  for i:=y to y2 do
   Begin
   e[i]:=k shr 16;
   es[i].x:=kx shr 16;
   es[i].y:=ky shr 16;
   k:=k+ki;
   kx:=kx+kxi;
   ky:=ky+kyi;
   End;
  End;

 Begin
 fillchar(re,sizeof(re),0);
 for i:=1 to sizeof(le) div 2 do le[i]:=320;
 calcedge(x,x2,y,y2,1,1,le,les,false,true);
 calcedge(x1,x3,y1,y3,60,1,re,res,false,true);
 calcedge(x,x1,y,y1,1,1,ue,ues,true,false);
 calcedge(x2,x3,y2,y3,1,60,de,des,true,false);
 for j:=1 to 200 do if (le[j]<320) or (re[j]>0) then
  Begin
  if le[j]=320 then
   if j<=y then
    Begin
    le[j]:=ue[j];
    les[j]:=ues[y1+y-j];
    end
    else
    Begin
    le[j]:=de[j];
    les[j]:=des[j];
    End;
  if re[j]=0 then
   if j<=y1 then
    Begin
    re[j]:=ue[j];
    res[j]:=ues[j];
    end
    else
    Begin
    re[j]:=de[j];
    res[j]:=des[y3+y2-j];
    End;
  if re[j]-le[j]=0 then inc(re[j]);

  pt:=calcy[j]+le[j];
  kx:=longint(les[j].x) shl 16;
  kxi:=round((res[j].x-les[j].x)/(re[j]-le[j] )*65536);
  ky:=longint(les[j].y) shl 16;
  kyi:=Round((res[j].y-les[j].y)/(re[j]-le[j])*65536);
  if le[j]<1 then
   begin
   kx:=kx+(kxi*abs(le[j]));
   ky:=ky+(kyi*abs(le[j]));
   pt:=pt+abs(le[j]);
   le[j]:=1;

   end;
  for i:=le[j] to min(re[j],320) do
   Begin
   p1^[pt]:=d.d[kx shr 16,ky shr 16];
   kx:=kx+kxi;
   ky:=ky+kyi;
   inc(pt);
   End;

  End;


 End;
{Procedure DMTn(x,y,x1,y1,x2,y2,x3,y3:Integer;Var d:Texture);
 var le,re,ue,de:EdgeArr;
     les,res,ues,des:Edgesrc;
     pt:word;
     i,j:integer;
     k,ki,kx,kxi,ky,kyi:real;
 Procedure calcedge(x,x2,y,y2,ix,iy:integer;var e:Edgearr;var es:Edgesrc;sckxi,sckyi:boolean);
  Var i:integer;
      k,ki,kx,kxi,ky,kyi:real;
  Begin

  if y2<y then
   Begin
   swi(y,y2);
   swi(x,x2);
   End;
  k:=x;
  kx:=ix;
  ky:=iy;
  if sckxi then kxi:=d.as/((y2-y) or 1)
   else kxi:=0;
  if sckyi then kyi:=d.df/((y2-y) or 1)
   else kyi:=0;
  ki:=(x2-x)/((y2-y) or 1);
  for i:=y to y2 do
   Begin
   e[i]:=round(k);
   es[i].x:=round(kx);
   es[i].y:=round(ky);
   k:=k+ki;
   kx:=kx+kxi;
   ky:=ky+kyi;
   End;
  End;

 Begin
 fillchar(re,sizeof(re),0);
 for i:=1 to sizeof(le) div 2 do le[i]:=320;
 calcedge(x,x2,y,y2,1,1,le,les,false,true);
 calcedge(x1,x3,y1,y3,d.as,1,re,res,false,true);
 calcedge(x,x1,y,y1,1,1,ue,ues,true,false);
 calcedge(x2,x3,y2,y3,1,d.df,de,des,true,false);
 for j:=1 to 200 do if (le[j]<320) or (re[j]>0) then
  Begin
  if le[j]=320 then
   if j<=y then
    Begin
    le[j]:=ue[j];
    les[j]:=ues[y1+y-j];
    end
    else
    Begin
    le[j]:=de[j];
    les[j]:=des[j];
    End;
  if re[j]=0 then
   if j<=y1 then
    Begin
    re[j]:=ue[j];
    res[j]:=ues[j];
    end
    else
    Begin
    re[j]:=de[j];
    res[j]:=des[y3+y2-j];
    End;

  pt:=calcy[j]+le[j];
  kx:=les[j].x;
  kxi:=(res[j].x-les[j].x)/((re[j]-le[j]) or 1);
  ky:=les[j].y;
  kyi:=(res[j].y-les[j].y)/((re[j]-le[j]) or 1);
  if le[j]<0 then
   Begin
   kx:=kx+abs(le[j])*kxi;
   ky:=ky+abs(le[j])*kyi;
   pt:=pt+abs(le[j]);
   le[j]:=0;
   End;
  for i:=le[j] to min(re[j],320) do
   Begin
   p[pt]:=d.d[round(kx),round(ky)];
   kx:=kx+kxi;
   ky:=ky+kyi;
   inc(pt);
   End;

  End;


 End;}



Procedure fdmt(x,y,x1,y1,x2,y2,x3,y3:Integer;Var d:texture);
 Var i,j,p:Integer;
     spa,ft:Word;
     h,hi:Real;
     ha,hai:Real;
     n,ni:Real;
     pa,pai:Real;
 Begin
 If (x<-100) or (x1<-100) or (x2<-100) or (x3<-100) or (x>420) or (x1>420) or (x2>420) or (x3>420) then exit;
 If (y<-100) or (y1<-100) or (y2<-110) or (y3<-110) or (y>300) or (y1>300) or (y2>300) or (y3>300) then exit;

 h:=y;
 If x1-x=0 then exit;
 hi:=(y1-y)/(x1-x);
 ha:=y2;
 If x3-x2=0 then exit;
 hai:=(y3-y2)/(x3-x2);
 pa:=1;
 if x1-x=0 then exit;
 pai:=d.as/(x1-x);
 For i:=x to x1 do
  Begin
  n:=1;
  if ha-h=0 then ni:=0
  else ni:=60/(ha-h);
  p:=Round(pa);
  if (i>0) and (i<320) then
   Begin
   spa:=i+Round(h)*320;
   For j:=max(Round(h),1) to Min(round(ha),200) do
    Begin
    p1^[spa]:=d.d[p,Round(n)];
    n:=n+ni;
    inc(spa,320);
    End;
   End;
  pa:=pa+pai;
  h:=h+hi;
  ha:=ha+hai;
  End;

 End;
Procedure Filled4k(x,y,x1,y1,x2,y2,x3,y3:integer;var d:texture);
 Var i,j:integer;
 Begin
 for i:=x2 to x3 do sline(x,y,i,y2+round(((i-x)/((x3-x) or 1))*(y3-y2)),d.d[1,1]);
 for i:=y3 to y2 do sline(x,y,x1+round(((i-y3)/((y2-y3) or 1))*(x3-x1)),i,d.d[1,1]);

 End;

Procedure Getpalette(var a:tpalette);
 Var i:byte;
 Begin
 port[$3c7]:=1;
 for i:=1 to 255 do
  Begin
  a[i].r:=port[$3c9];
  a[i].g:=port[$3c9];
  a[i].b:=port[$3c9];
  End;
 End;
Procedure initpalette(a:tpalette);
 Var i:byte;
 Begin
 port[$3c8]:=1;
 for i:=1 to 255 do
  Begin
  port[$3c9]:=a[i].r;
  port[$3c9]:=a[i].g;
  port[$3c9]:=a[i].b;
  End;
 End;


Procedure D3DT (x,y,x1,y1,x2,y2,x3,y3:Integer;Var d:texture);
 Var l,fu,i,j,b,f,e,m:Integer;
 ha,va,n,ni,ty:Real;
 u,dn,le,ra,lc,rc:Real;
 hr1,hr2,vr2:Integer;
 Begin
 hr1:=x2-x;
 hr2:=x3-x1;
 vr2:=y3-y1;
 For j:=y to y2 do
  Begin
  va:=(1+j-y)/(y2-y);
  b:=x+round(hr1*va);
  e:=x1+Round(hr2*va);
  l:=e-b;
  ni:=1/l;
  n:=0;
  ty:=(y1-1)+(vr2*va)-j;
  m:=trunc(va*d.df);
  dn:=va*d.df-int(va*d.df);
  u:=1-dn;
  For i:=b to e do
   Begin
   n:=n+ni;
   ra:=n*d.as-int(n*d.as);
   le:=1-ra;
   fu:=trunc(n*d.as);
   lc:=u*d.d[fu+1,m]+dn*d.d[fu+1,m+1];
   rc:=u*d.d[fu+2,m]+dn*d.d[fu+2,m+1];
   wDraw(i,j+round(n*ty),Round(le*lc+ra*rc));
              End
  End;
 End;
Procedure TR(v:T3dCoords;Var x,y:integer);
 Begin
{ if v.x>320 then exit;
 if v.y>500 then exit;}
 If (round(v.y)<=0) then
 Begin
 x:=0;
 y:=0;
 exit;
 End;
 x:=Round(((v.x)*hscale)/(v.y))+160;
 y:=Round(((v.z-50)*vscale)/(v.y))+100;
 End;
Procedure v640TR(v:T3dCoords;Var x,y:integer);
 Begin
 If (round(v.y)=-100) or (round(v.y)=-160) then exit;
 x:=Round(((v.x)*1024)/(320+v.y))+320;
 y:=Round(((v.z-50)*vscale*5)/(240+v.y))+240;
 End;

Procedure ftr(v:T3dCoords;Var x,y:integer);
 Begin
 x:=Round(v.x);
 y:=Round(v.y);
 End;

Procedure rTR(v:T3dCoords;Var x,y:real);
 Begin
{ if v.x>320 then exit;
 if v.y>500 then exit;}
 If v.y<1 then
  Begin
  x:=0;
  y:=0;
  exit;
  End;
 x:=((v.x)*256)/(160+v.y)+160;
 y:=((v.z-50)*vscale)/(100+v.y)+100;
 End;
procedure SetVscale(a:integer);
 Begin
 vscale:=a;
 End;
procedure SetHscale(a:integer);
 Begin
 hscale:=a;
 End;

Procedure LoadBmp(Name:String);
 Var as:Tpalette;
     c:char;
     t:text;
     i,j:Word;
     b:Boolean;
 Begin
 Assign(t,name);
 Reset(t);
 Read(t,c);
 b:=(c='B');
 Read(t,c);
 b:=b and (c='M');
 If not b then
  Begin
  Close(t);
  exit;
  End;
 For i:=1 to 52 do Read(t,c);
 For i:=0 to 255 do
  Begin
  Read(t,c);
  as[i].b:=(Ord(c)) div 4;
  Read(t,c);
  as[i].g:=(Ord(c)) div 4;
  Read(t,c);
  as[i].r:=(Ord(c)) div 4;
  Read(t,c);
  End;
 InitPalette(as);
 For i:=200 downto 1 do
  For j:=1 to 320 do
   Begin
   Read(t,c);
   Vdraw(j,i,Ord(c));
   End;
 Close(t);
 End;
Procedure GetBlock(x,y:word;Var a:TBlock);
 Var i,j:word;
 Begin
 for i:=1 to 8 do
  For j:=1 to 8 do a[j,i]:=wpoint((x-1)*8+j-1,(y-1)*8+i-1);
 End;
Procedure Putblock(x,y:word;a:TBlock);
 var i,j:word;
 Begin
 for i:=1 to 8 do
  For j:=1 to 8 do vdraw((x-1)*8+j-1,(y-1)*8+i-1,a[j,i]);
 End;

Procedure vBlock(a:TBlock);
 Var i,j:word;
 Begin
 for i:=1 to 8 do
  for j:=1 to 8 do
   Begin
   vbrick((j-1)*40,(i-1)*25,40,25,a[j,i]);
   line((j-1)*40,i*25,j*40,i*25,0);
   line(j*40,(i-1)*25,j*40,i*25,0);
   end;

 End;
Function Bool2Byte(q:bitbyte):Byte;
 Var i,an:byte;
 Begin
 an:=0;
 for i:=1 to 8 do an:=an or byte(byte(q[i]) shl (8-i));
 Bool2byte:=an;
 End;
Procedure Byte2bitbyte(a:byte;var b:bitbyte);
 Var i:byte;
 Begin
 for i:=1 to 8 do b[i]:=((1 shl (8-i)) and a<>0);
 End;
Procedure Decodechunk(c:tchunk;var b:Tblock);
 var e:tvt;
     i,j,k:word;
 Begin
  case c[1] of
  $a0:Begin
      fillchar(b,sizeof(b),c[2]);
      for i:=1 to 8 do byte2bitbyte(c[i+2],e[i]);
      k:=11;
      for j:=1 to 8 do
       for i:=1 to 8 do if e[i,j] then
        Begin
        b[i,j]:=c[k];
        inc(k);
        End;
      End;
  $a1:fillchar(b,sizeof(b),c[2]);
  else fillchar(b,sizeof(b),0);
  End;
 end;
Function Count1(a:Byte):Byte;
 Var c:byte;
 Begin
 c:=0;
 while a<>0 do
  Begin
  inc(c);
  a:=a and (a-1);
  End;
 count1:=c;
 End;



Procedure loadVPG(filename:string);
 Var t:text;
     c:char;
     ch:tchunk;
     b:tblock;
     i,j,k:word;
     l:byte;
     d:array [1..4608] of boolean;
     f:bitbyte;
     z:tpalette;
 Begin
 Assign(t,filename);
 reset(T);
 Read(t,c);
 if c<>'V' then
  Begin
  close(t);
  exit;
  End;
 read(t,c);
 for i:=1 to 576 do
  begin
  read(t,c);
  byte2bitbyte(ord(c),f);
  for j:=1 to 8 do d[(i-1)*8+j]:=f[j];
  End;
 k:=0;
 for i:=1 to 255 do
  Begin
  for j:=1 to 6 do f[j+2]:=d[k+j];
  z[i].r:=bool2byte(f) mod 64;
  inc(k,6);
  for j:=1 to 6 do f[j+2]:=d[k+j];
  z[i].g:=bool2byte(f) mod 64;
  inc(k,6);
  for j:=1 to 6 do f[j+2]:=d[k+j];
  z[i].b:=bool2byte(f) mod 64;
  inc(k,6);
  End;
  initpalette(z);
  for j:=1 to 25 do
   For i:=1 to 40 do
    Begin
    Read (t,c);
    case c of
    #$A0:Begin
         k:=0;
         ch[1]:=$a0;
         for l:=1 to 9 do
          Begin
          Read(t,c);
          ch[l+1]:=ord(c);
          End;
         For l:=3 to 10 do k:=k+count1(ch[l]);
         for l:=1 to k do
          Begin
          read(t,c);
          ch[10+l]:=ord(c);
          End;
         End;
    #$A1:Begin
         ch[1]:=$A1;
         read(t,c);
         ch[2]:=ord(c);

         End;
     else ch[1]:=$FF;
    End;
    decodechunk(ch,b);
    PutBlock(i,j,b);
    End;


 End;
Procedure Gotoxy(x,y:byte);
 Begin
 asm
 mov dl,x
 mov dh,y
 mov bh,0
 mov ah,2
 int 10h
 End;
 mem[$0b800:(x+y*80)*2+1]:=sa;
 End;
Procedure GeneratePalette(Var z:Tpalette;a:TpaletteType);
{
-==========================================-
This procedure creates a palette, organised
as the given array "a" of TPaletteType.
The idea is the following:

   |     A:    |     Z:    |
col| r | g | b | R | G | B |
---+---+---+---+-----------|
 1 | 5 | 19| 63| 5 | 19| 63|
 2 | ? | ? | ? | 5 | 22| 61|
 3 | ? | ? | ? | 6 | 25| 59|
 4 | ? | ? | ? | 7 | 27| 57|
 5 | ? | ? | ? | 7 | 30| 55|
 6 | ? | ? | ? | 8 | 33| 53|
 7 | ? | ? | ? | 9 | 36| 51|
 8 | ? | ? | ? | 9 | 39| 49|
 9 | ? | ? | ? | 10| 42| 46|
10 | ? | ? | ? | 11| 45| 44|
11 | ? | ? | ? | 11| 48| 42|
12 | ? | ? | ? | 12| 51| 40|
13 | ? | ? | ? | 13| 54| 38|
14 | ? | ? | ? | 13| 57| 36|
15 | ? | ? | ? | 14| 60| 34|
16 | 15| 63| 32| 15| 63| 32|
----------------------------
so it fills Z with the missing
information of A
-==========================================-
}
 Var i,j,k:byte;
 r,g,b,ri,gi,bi:real;
 Begin
 j:=1;
 while (a[j].colnum<>0) and (j<=16) do inc(j);
 j:=j-1;
 for i:=1 to j-1 do
  Begin
  r:=a[i].r;
  g:=a[i].g;
  b:=a[i].b;
  ri:=(a[i+1].r-a[i].r)/(a[i+1].colnum-a[i].colnum);
  gi:=(a[i+1].g-a[i].g)/(a[i+1].colnum-a[i].colnum);
  bi:=(a[i+1].b-a[i].b)/(a[i+1].colnum-a[i].colnum);
  for k:=a[i].colnum to a[i+1].colnum do
   Begin
   z[k].r:=round(r);
   z[k].g:=round(g);
   z[k].b:=round(b);
   r:=r+ri;
   g:=g+gi;
   b:=b+bi;
   End;
  End;
 End;




BEGIN
for tiptr:=0 to 200 do calcy[tiptr]:=tiptr*320;
mode:=03;
vscale:=160;
hscale:=160;
sa:=07;
END.

Procedure DMT (x,y,x1,y1,x2,y2,x3,y3:integer;Var d:texture);
 Procedure DMT1 (x,y,x1,y1,x2,y2,x3,y3:integer;Var d:texture);
 Var i,j,b,e,l,m:integer;
 va,n,ni,vai,ty:Real;
 hr1,hr2,vr2:Integer;
 Begin
 If (x<0) and (x1<0) and (x2<0) and (x3<0) then exit;
 If (x>320) and (x1>320) and (x2>320) and (x3>320) then exit;
{ If (x1<=x) or (y2<=y) then exit;}
 hr1:=x2-x;
 hr2:=x3-x1;
 vr2:=y3-y1;
 If y2-y=0 then exit;
 Vai:=1/(y2-y);
 Va:=0;
 For j:=y to y2 do
  Begin
  va:=va+vai;
  b:=x+Round(hr1*va);
  e:=x1+Round(hr2*va);
  If e-b=0 then exit;
  ni:=d.as/(e-b);
  n:=0;
  ty:=Round((y1-1)+(vr2*va))-j;
  m:=Round(va*d.df);
  ty:=ty/d.as;
  If Abs(ty)>(1/d.as) then
  For i:=Round(b) to Round(e) do
   Begin
   n:=n+ni;
   wDraw(i,(j+round(n*ty)),d.d[round(n)+1,m]);
   End
   Else
  For i:=Round(b) to Round(e) do
   Begin
   n:=n+ni;
   WDraw(i,j,d.d[round(n)+1,m]);
   End;
  End;
 End;
 Procedure DMT2 (x,y,x1,y1,x2,y2,x3,y3:integer;Var d:texture);
 Var i,j,b,e,l,m:integer;
 va,n,ni,vai,ty:Real;
 hr1,hr2,vr2:Integer;
 Begin
 If (x<0) and (x1<0) and (x2<0) and (x3<0) then exit;
 If (x>320) and (x1>320) and (x2>320) and (x3>320) then exit;
{ If (x1<=x) or (y2<=y) then exit;}
 hr1:=x2-x;
 hr2:=x3-x1;
 vr2:=y2-y;
 If y3-y1=0 then exit;
 Vai:=1/(y3-y1);
 Va:=0;
 For j:=y1 to y3 do
  Begin
  va:=va+vai;
  b:=x+Round(hr1*va);
  e:=x1+Round(hr2*va);
  If e-b=0 then exit;
  ni:=d.as/(e-b);
  n:=d.as+2;
  ty:=Round((y-1)+(vr2*va))-j;
  m:=Round(va*d.df);
  ty:=ty/d.as;
  If Abs(ty)>(1/d.as) then
  For i:=Round(e) downto Round(b) do
   Begin
   n:=n-ni;
   wDraw(i,(j+round((d.as-n)*ty)),d.d[round(n),m]);
   End
   Else
  For i:=Round(e) downto Round(b) do
   Begin
   n:=n-ni;
   WDraw(i,j,d.d[round(n)+1,m]);
   End;
  End;
 End;

 Begin
 If (y2-y)>(y3-y1) then dmt1 (x,y,x1,y1,x2,y2,x3,y3,d)
  else dmt2 (x,y,x1,y1,x2,y2,x3,y3,d);
 End;
