{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

Unit Stdlib;
interface
const maxx=25;
type tarr=array [0..maxx] of byte;
Function Min(a,b:word):word;
Function Max(a,b:word):word;
Procedure Sw(var a,b:integer);
Procedure Swb(var a,b:byte);
Procedure Sww(var a,b:word);
Procedure Swl(var a,b:longint);
Procedure Swr(var a,b:real);
Procedure Swc(var a,b:char);
Procedure Sws(var a,b:string);
Function Fileexists(filename:string):boolean;
Function lowcase(ch:char):char;
Function Signof(a:real):integer;
Function Byte2ASCII(a:Byte):char;
Function Dec2Hex(a:word):string;
Function Upstring(s:string):string;
Procedure bubsort(var a:Tarr;n:word);
Function Keypressed:Boolean;
Function Readkey:Char;
Procedure purg;
Procedure Pause;
Procedure cls;


implementation
Function Min(a,b:word):word;
 Begin
 if a<b then min:=a
  else min:=b;
 End;
Function Max(a,b:word):word;
 Begin
 if a>b then max:=a
  else max:=b;
 End;

Procedure Sw(var a,b:integer);
 Var c:integer;
 Begin
 c:=a;
 a:=b;
 b:=c;
 End;
Procedure Swb(var a,b:byte);
 Var c:byte;
 Begin
 c:=a;
 a:=b;
 b:=c;
 End;
Procedure Sww(var a,b:word);
 Var c:word;
 Begin
 c:=a;
 a:=b;
 b:=c;
 End;
Procedure Swl(var a,b:longint);
 Var c:longint;
 Begin
 c:=a;
 a:=b;
 b:=c;
 End;
Procedure Swr(var a,b:real);
 Var c:real;
 Begin
 c:=a;
 a:=b;
 b:=c;
 End;
Procedure Swc(var a,b:char);
 Var c:char;
 Begin
 c:=a;
 a:=b;
 b:=c;
 End;
Procedure Sws(var a,b:string);
 Var c:string;
 Begin
 c:=a;
 a:=b;
 b:=c;
 End;
Function Fileexists(filename:string):boolean;
 var f:file;
 Begin
 assign(f,filename);
 {$I-}
 filemode:=0;
 reset(f);
 Close(f);
 {$I+}
 Fileexists:=(IoResult=0) and (filename<>'');
 End;
Function Signof(a:real):integer;
 Begin
 if a>=0 then signof:=+1
  else signof:=-1;
 End;
Function lowcase(ch:char):char;
 Begin
 lowcase:=ch;
 if ch in ['A'..'Z'] then lowcase:=chr(ord(ch)+32);
 if ch in [''..''] then lowcase:=chr(ord(ch)+32);
 End;
Function Byte2ASCII(a:Byte):char;
 Begin
 a:=a+$30;
 if a>$39 then a:=a+7;
 byte2ascii:=lowcase(chr(a));
 End;
Function dec2hex(a:word):string;
 Var s:string;
 Begin
 s:=byte2ascii((a shr 12) and $0f)+byte2ascii((a shr 8) and $0f)+byte2ascii((a shr 4) and $0f)+byte2ascii(a and $0f);
 dec2hex:=s;
 End;

function Upstring(s:string):string;
 var i:byte;
     g:string;
 begin
 g:='';
 for i:=1 to length(s) DO g:=g+upcase(s[i]);
 Upstring:=g;
 end;

Procedure bubsort(var a:Tarr;n:word);
 Var b:boolean;
     i,d:word;
 Begin
 d:=n-1;
 Repeat
 b:=FALSE;
 For i:=1 to d do if a[i]>a[i+1] then
  Begin
  swb(a[i],a[i+1]);
  b:=TRUE;
  End;
 dec(d);
 Until not b;
 End;
Function Keypressed:Boolean;
 var a:Byte;
 Begin
 Asm
 mov ah,11
 int 33
 mov a,al
 End;
 Keypressed:=(a<>0);
 End;
Function Readkey:Char;
 Var c:Char;
 begin
 asm
 mov ah,7
 int 33
 mov c,al
 End;
 Readkey:=c;
 End;
Procedure Cls;
 Begin
  ASM
  MOV AX,3
  INT 10H
  END;
 End;
Procedure purg;
 Begin
 while keypressed do readkey;
 End;
Procedure Pause;
 Begin
 Repeat until keypressed;
 purg;
 End;
Procedure Gotoxy(x,y:byte);
 Begin
 asm
 mov dl,x
 mov dh,y
 mov bh,0
 mov ah,2
 int 10h
 End;
 End;

BEGIN
END.