{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q+,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
Program tetris;

Uses stdlib,DMAGraph;
Const hgt=20;
Type TTeblock=Array [1..3,1..3] of byte;
     TAlBlocks=Array [1..9] of TTeBlock;
     TTeScreen=Array [1..8,1..hgt] of byte;
     TTeSqr=Array [1..10,1..10] of byte;
     TTeSqrArr=array [1..15] of TTeSqr;
     ControlBlk=record
                x,y,color:byte;
                b:TTeBlock;
                active:Boolean;
                End;
     Tpersonrecord=Record
                   name:string[40];
                   score:longint;
                   End;
     TScrFile=file of TPersonRecord;
     TSaveBlock=Record
                name:string;
                c:ControlBlk;
                v:TTeScreen;
                score:longint;
                prd,fontptr,level:byte;


                End;
     TSaveFile=File Of TSaveBlock;
     TVeMenu=record
             items:byte;
             text:String;
             item:array [1..10] of string;
             entry,default:byte;
             End;

Type largechar=array [1..8,1..10] of byte;
     Byteofbyte=array [byte] of byte;
     largefont=array [32..127] of largechar;
     TBoundArr=array [1..15] of longint;

Var a:largechar;
    d:byteofbyte;
    b:largeFont;
    e:TTeSqrArr;
    res:Byte;


Const
     h:TalBlocks=(((0,0,0),(0,1,1),(0,1,1)),((0,0,0),(1,1,1),(0,1,0)),
     ((0,0,0),(0,1,1),(1,1,0)),((0,0,0),(1,1,0),(0,1,1)),
     ((0,0,0),(1,0,0),(1,1,1)),((0,0,0),(0,0,1),(1,1,1)),
     ((0,1,0),(0,1,0),(0,1,0)),((0,0,0),(0,1,1),(0,0,1)),
     ((0,0,0),(0,1,0),(0,1,0)));
Const medigame:TVeMenu=(items:3;text:'GAME PAUSED.';item:('Save Game','Continue Game',
'Exit Game','','','','','','','');entry:1;default:2);
      MainMenu:TVeMenu=
      (Items:5;
       text:'';
       item:('New Game',
             'Load Game',
             'Show Hall Of Fame',
             'Help',
             'Exit',
             '','','','','');
       entry:1;
       default:5);
      barr:TBoundArr=(0,2000,5000,12000,25000,60000,140000,300000,700000,1500000,3200000,7000000,15000000,35000000,70000000);
Var v:TTeScreen;
    c:ControlBlk;
Procedure Generatescr;
 Var t:TScrFile;
     a:TPersonRecord;
     i:byte;
 Begin
 a.name:='Nobody';
 a.score:=0;
 assign(t,'tetris.scr');
 Rewrite(t);
 for i:=1 to 10 do write(t,a);
 close(t);
 End;
Function Getstr(var t:text):String;
 var s:string;
 Begin
 If eof(t) then
  Begin
  getstr:='        ';
  exit;
  End;
 s:=';';
 While s[1]=';' do readln(t,s);
 s:=copy(s,1,8);
 while length(s)<8 do s:=s+' ';
 getstr:=s;

 End;

Procedure Loadfont(fn:string);
 Var
    c:char;
    s:string;
    i,j,k:byte;
    t:Text;
 Begin
 fillchar(d,sizeof(d),0);
 assign(t,fn);
 Reset(t);
 readln(t,s);
 for i:=1 to 4 do d[ord(s[i])]:=31-(i-1)*5;
 for k:=32 to 127 do
  for j:=1 to 10 do
   Begin
   s:=Getstr(t);
   for i:=1 to 8 do b[k][i,j]:=d[ord(s[i])];
   End;

 Close(t);
 End;
Procedure wfwrite(x,y:Integer;s:string;dummy:byte);
 var k,i,j:word;
 Begin
 for k:=1 to length(s) do
  for j:=1 to 10 do
   for i:=1 to 8 do wdraw(i-1+x+k*8-8,y+j-1,b[ord(s[k])][i,j]);

 End;


Procedure Intro;
 var i,j:Byte;
     d:texture;
     c:byte;
 Begin
 chmod($13);
 c:=1;
 if fileexists ('tetris.vpg') then inc(c);
 c:=random(c);
 case c of
 1:loadvpg('Tetris.vpg');
 0:  begin
      asm
      mov cx,63
      mov ax,1
      mov dx,3c8h
      out dx,al
      inc dx
@kloop:
      out dx,al
      xchg ah,al
      out dx,al
      xchg ah,al
      out dx,al
      inc al
      loop @kloop
      end;

      fillscr0(0);
      wfwrite(1,20,'Vessko''s',15);
      wfwrite(6,31,'Tetris',15);
      fillchar(d.d,sizeof(d.d),0);
      for j:=1 to 60 do
       for i:=1 to 60 do if wpoint(i,j)<>16 then d.d[i,j]:=2*wpoint(i,j);
      d.as:=59;
      d.df:=59;
      d3dt(2,2,318,2,2,198,318,198,d);
      copyall;
      End;
  End;
 pause;
 chmod($13);
 End;
Procedure Showhall;
 var t:TSCRFile;
     s,s1:string;
     i:byte;
     a:Tpersonrecord;
 Begin
 fillscr0(0);
 wfwrite(5,1,'HALL OF FAME: (Da best Chin-Chuns)',15);
 assign(t,'Tetris.scr');
 Reset(t);
 for i:=1 to 10 do
  Begin
  read(t,a);
  str (i,s);
  s:=s+'. '+copy(a.name,1,23);

  while length(s)<23 do s:=s+'.';
  str(a.score,s1);
  while length(s1)<9 do s1:='.'+s1;
  wfwrite(15,i*10+i,s+s1,15);
  End;
 Close(t);
 copyall;
 pause;
 End;
Function Menu(Var a:TVeMenu):byte;
 Var i,j:Word;
     curr:byte;
     c:char;
 Procedure redrawmenu;
  Var i,j,y,y1,x,y2:WORD;
  Begin
  y:=100-(11*a.items+21) div 2;
  y1:=100+(11*a.items+21) div 2;
  For i:=2 to 318 do
   for j:=y to y1 do wdraw(i,j,0);
  sline(2,y,318,y,7);
  sline(2,y,2,y1,7);
  sline(2,y1,318,y1,7);
  sline(318,y,318,y1,7);
  wfwrite(160-length(a.text)*4,y+5,a.text,15);
  for i:=1 to a.items do wfwrite(160-length(a.item[i])*4,y+5+i*11,a.item[i],15);
  x:=160-length(a.item[curr])*4-4;
  y2:=y+4+curr*11;
  wdraw(x+1,y2+5,31);
  wdraw(x+1,y2+6,26);
  wdraw(x+1,y2+4,26);
  wdraw(x,y2+5,26);
  wdraw(x+2,y2+5,26);
  for i:=x to 316 do
   for j:=y2 to y2+10 do if wpoint(i,j)<>0 then wdraw(i,j,wpoint(i,j)+13*16);

  copyall;
  End;
 Begin
 curr:=a.entry;
 Repeat
 redrawmenu;
 repeat until keypressed;
 c:=REadkey;
 case c of
 #0:Begin
    c:=Readkey;
    if c=#72 then dec(curr);
    if c=#80 then inc(curr);
    if curr>a.items then curr:=1;
    if curr<1 then curr:=a.items;

    End;
 #27:Begin
     menu:=a.default;
     exit;
     End;
 #13:Begin
     menu:=curr;
     exit;
     End;
   End;
 Until False;


 End;

Procedure Help;
 var t:Text;
     s:String;
     i:Byte;
 Begin
 fillscr0(0);
 if not fileexists('tetris.hlp') then wfwrite(100,100,'Help File Missing.',15)
 else Begin
      i:=0;
      assign(t,'tetris.hlp');
      reset(t);
      while not eof(t) do
       Begin
       readln(t,s);
       wfwrite(1,(i mod 20)*10+1,s,15);
       if i mod 20=19 then
        Begin
        copyall;
        pause;
        fillscr0(0);
        End;
       inc(i);

       End;
       close(t);
      End;
 copyall;
 pause;

 End;

Procedure Message(Mess:String);
 Var i,j,lx:word;
 Begin
 lx:=length(mess)*4;
 for i:=160-lx-6 to 160+lx+6 do
  for j:=90 to 110 do if (i in [160-lx-6,160+lx+6]) or (j in [90,110]) then wdraw(i,j,15)
  else wdraw(i,j,0);
 wfwrite(160-lx,95,mess,15);
 copyall;
 End;

Function strInput(mess:string;s:string):string;
 var c:char;
     i,j:word;
     x,x1:word;
  Begin
   Repeat
   x:=min(160-length(mess)*4-5,160-length(s)*4-5);
   x1:=max(160+length(mess)*4+5,160+length(s)*4+5);
   for i:=x to x1 do
    for j:=85 to 115 do if (i in [x,x1]) or (j in [85,115]) then wdraw(i,j,15)
    else wdraw(i,j,0);

   wfwrite(160-length(mess)*4,90,mess,15);
   wfwrite(160-4*length(s),100,s,15);
   copyall;
   repeat until keypressed;
   c:=Readkey;
   if c=#8 then delete(s,length(s),1);
   if not (c in [#0..#31]) then s:=s+c;
   if c=#0 then c:=Readkey;
   Until (c=#27) or (c=#13);
  strinput:=s;
  End;



Procedure Game(newgame:boolean);
 Var She:Boolean;
     i,j:word;
     ch:char;
     olscr,score:longint;
     prd,fontptr:byte;
     level:byte;
     d:longint;
     kl:Byte;
     l:longint absolute 0:$046c;
 Procedure Initc;
  var i,j:Byte;
  Begin
  c.x:=3;
  c.y:=1;

  c.color:=random(14)+1;
  c.b:=h[prd];
  prd:=random(9)+1;
  for i:=1 to 3 do
   for j:=1 to 3 do if c.b[i,j]<>0 then c.b[i,j]:=c.color;
  End;
 Procedure PutSqr(x,y:word;c:byte);
  Var i,j:word;
  Begin
{  for j:=y to y+10 do
   for i:=x to x+10 do if (i=x) or (i=x+10) or (j=y) or (j=y+10) then wdraw(i,j,15)
    else wdraw(i,j,c);}
  for j:=y to y+9 do
   for i:=x to x+9 do if (j in [11+y,y+10]) or (i in [x+11,x+10]) then wdraw(i,j,15)
   else wdraw(i,j,e[c][i-x+1,j-y+1]);

  End;

 Procedure Redraw;
  var i,j,ii,jj:word;

      s:string;
  Begin
  fillscr0(0);
  for j:=1 to 20 do
   for i:=1 to 8 do if v[i,j]<>0 then putsqr(110+i*10,j*10-10,v[i,j]);
  for j:=1 to 3 do
   for i:=1 to 3 do if c.b[i,j]<>0 then putsqr(100+c.x*10+i*10,c.y*10-10+(j-1)*10,c.b[i,j]);
  sline(120,1,120,200,15);
  sline(200,1,200,200,15);
  sline(120,199,200,199,15);
  str(score,s);
  wfwrite(202,40,'score:'+s,15);
  str(level,s);
  wfwrite(202,50,'level:'+s,15);
  wfwrite(202,60,'next:',15);
  for j:=1 to 3 do
   for i:=1 to 3 do if h[prd][i,j]<>0 then for jj:=0 to 1 do
    for ii:=0 to 1 do wdraw(246+i*2+ii,60+j*2+jj,13);
  copyall;
  End;
 Function Problems:Boolean;
  Var i,j:byte;
      x,y:byte;
      f:boolean;
  Begin
  f:=FALSE;
  for j:=1 to 3 do
   for i:=1 to 3 do
    Begin
    x:=c.x+i-1;
    y:=c.y+j-1;
    f:=f or ((c.b[i,j]<>0) and ((x<1) or (x>8) or (y>20) or (v[x,y]<>0)));
    End;
  Problems:=F;

  End;
 Procedure pastec;
  var i,j:byte;
  Begin
  for j:=1 to 3 do
   for i:=1 to 3 do if c.b[i,j]<>0 then v[i+c.x-1,c.y+j-1]:=c.b[i,j];
  End;
 Procedure turnl;
  Var n:TTeBlock;
   i,j:byte;
  Begin
  n:=c.b;
  c.b[1,1]:=n[1,3];
  c.b[2,1]:=n[1,2];
  c.b[3,1]:=n[1,1];
  c.b[1,2]:=n[2,3];
  c.b[2,2]:=n[2,2];
  c.b[3,2]:=n[2,1];
  c.b[1,3]:=n[3,3];
  c.b[2,3]:=n[3,2];
  c.b[3,3]:=n[3,1];

  End;
 Procedure turnr;
  Begin
  turnl;
  turnl;
  turnl;
  End;
 Function scanlines:longint;
  Var i,j,k,l:byte;
      f:boolean;
      c:byte;
  Begin
  c:=0;
  for j:=hgt downto 1 do
   Begin
   f:=TRUE;
   for i:=1 to 8 do f:=f and (v[i,j]<>0);
   if f then inc (c);
   End;
  for j:=1 to hgt do
   Begin
   f:=TRUE;
   for i:=1 to 8 do f:=f and (v[i,j]<>0);
   if f then
    Begin
    for k:=j downto 2 do for l:=1 to 8 do v[l,k]:=v[l,k-1];
    for l:=1 to 8 do v[l,1]:=0;
    End;
   End;
  case c of
  0:scanlines:=0;
  1:scanlines:=100;
  2:scanlines:=300;
  3:scanlines:=1500;
  4:scanlines:=4200;
  else scanlines:=0;
  end;
  End;

 Procedure Gameover;
  Var i,j:word;
      a:TPersonRecord;
      b:array [1..10] of TPersonRecord;
      t:TScrFile;
      s:string;
      c:char;
  Begin
  for i:=1 to 4 do
   Begin
   for j:=0 to 15999 do p[j*4+i]:=0;
   asm
   mov ah,86h
   mov cx,3
   mov dx,814
   int 15h
   end;
   End;
  fillscr0(0);
  wfwrite(120,90,'Game Over.',15);
  copyall;
  purg;
  pause;
  Assign(t,'Tetris.scr');
  Reset(t);
  i:=1;
  read(t,a);
  while (i<10) and (score<a.score) do
   Begin
   b[i]:=a;
   read(t,a);
   Inc(i);
   End;

  if i=10 then exit;
  if i<>10 then b[i+1]:=a;
  s:='';
  Repeat
  Fillscr0(0);
  wfwrite(100,90,'Enter Your Name',15);
  wfwrite(160-4*length(s),100,s,15);
  copyall;
  repeat until keypressed;
  c:=Readkey;
  if c=#8 then delete(s,length(s),1);
  if not (c in [#0..#31]) then s:=s+c;
  if c=#0 then c:=Readkey;
  Until (c=#27) or (c=#13);
  a.name:=s;
  a.score:=score;
  b[i]:=a;
  i:=i+2;
  while i<11 do
   Begin
   read(t,a);
   b[i]:=a;
   inc(i);
   End;
  close(t);
  assign(t,'Tetris.scr');
  REwrite(t);
  for i:=1 to 10 do write(t,b[i]);
  Close(t);
  showhall;
  End;
 Procedure Savegame;
  Var f:TSaveFile;
      a:TSaveBlock;
      b:TVEMenu;
      ck:Array [1..10] of Tsaveblock;
      i,j:Byte;
  Begin
  assign(f,'tetris.sav');
  Reset(f);
  for i:=1 to 10 do
   Begin
   read(f,a);
   b.item[i]:=a.name;
   ck[i]:=a;
   End;
  b.items:=10;
  b.text:='Choose a Game To Save:';
  b.entry:=1;
  b.default:=11;
  i:=Menu(b);
  if i=11 then
   Begin
   Close(f);
   Exit;
   End;
  Close(f);
  a.name:=strinput('Name to Save:',b.item[i]);
  a.score:=score;
  a.v:=v;
  a.c:=c;
  a.prd:=prd;
  a.level:=level;
  a.fontptr:=fontptr;
  ck[i]:=a;

  assign(f,'tetris.sav');
  Rewrite(f);
  for i:=1 to 10 do write(f,ck[i]);
  Close(F);
  End;
 Function loadgame:boolean;
  Var f:TSaveFile;
      a:TSaveBlock;
      b:TVEMenu;
      i,j:Byte;
  Begin
  assign(f,'tetris.sav');
  Reset(f);
  for i:=1 to 10 do
   Begin
   read(f,a);
   b.item[i]:=a.name;
   End;
  b.items:=10;
  b.text:='Choose a Game To Load:';
  b.entry:=1;
  b.default:=11;
  Repeat
  i:=Menu(b);
  if i=11 then
   Begin
   LoadGame:=FALSE;
   Close(f);
   Exit;
   End;
  if b.item[i]='<EMPTY>' then
   Begin
   Message('You Cannot Load Empty Entries.');
   pause;
   End;

  Until b.item[i]<>'<EMPTY>';
  reset(f);
  for j:=1 to i do read(f,a);
  score:=a.score;
  v:=a.v;
  c:=a.c;
  prd:=a.prd;
  level:=a.level;
  fontptr:=a.fontptr;
  SHE:=FALSe;
  Close(F);
  Loadgame:=TRUE;
  End;


 Begin
 If newgame then
  Begin
  score:=0;
  level:=1;
  she:=FALSE;
  prd:=random(9)+1;
  fontptr:=0;

  fillchar(v,sizeof(v),0);
  initc;
  End
  else if not loadgame then exit;
 Repeat
 redraw;
 d:=l;
  repeat
  if keypressed then
   Begin
   ch:=Readkey;
   case ch of
   #27:Begin
       kl:=Menu(medigame);
        case kl of
        1:savegame;
        3:she:=TRUE;
        end;
       End;
   'f','F':Begin
           inc(fontptr);
           case fontptr mod 2 of
           1:loadFont('Digifont.txt');
           0:loadfont('font.txt');
           End;
           End;

   ',','<':Begin
           turnl;
           if problems then turnr;
           redraw;
           End;
   '.','>':Begin
           turnr;
           if problems then turnl;
           redraw;
           End;


   #0:Begin
      ch:=REadkey;

      case ch of
      #75:Begin

          dec(c.x);
          if problems then inc(c.x);
          redraw;
          End;
      #77:Begin
          inc(c.x);
          if problems then dec(c.x);
          redraw;
          End;
      #80:Begin
          inc(c.y);
          if problems then dec(c.y);
          redraw;
          end;
      End;

      End;
   End;
   End;

  Until l-d>=13-level;
 inc(c.y);
 If problems then
  Begin
  dec(c.y);
  pastec;
  initc;
  inc(score,5);
  score:=score+scanlines;
  for i:=1 to 15 do if barr[i]<score then level:=i;
  if problems then she:=TRUE;
  End;



 until she;
 Gameover;
 End;
Procedure Initsqrs;
 Var g:array [0..11,0..11] of byte;
     k:byte;
     i,j,l:Byte;
     z:Tpalette;
 Begin
 for k:=1 to 14 do
  Begin
  fillchar(g,sizeof(g),0);
  for i:=0 to 11 do for j:=0 to 11 do if (i in [0,11]) or (j in [0,11]) then g[i,j]:=7;
  for i:=1 to 250 do g[random(10)+1,random(10)+1]:=random(15)+1;
  for l:=1 to 2 do
   Begin
   for j:=1 to 10 do
    for i:=1 to 10 do e[k][i,j]:=(k+1)*16+round((g[i,j]*2+g[i-1,j]+g[i+1,j]+g[i,j-1]+g[i,j+1])/6);
   for j:=1 to 10 do
    for i:=1 to 10 do g[i,j]:=e[k][i,j]-(k+1)*16;
   End;
  End;
  Getpalette(z);
  for k:=1 to 14 do
   for i:=(k+1)*16 to (k+1)*16+15 do
    Begin
    z[i].r:=round((i-(k+1)*16)/16*z[k].r);
    z[i].g:=round((i-(k+1)*16)/16*z[k].g);
    z[i].b:=round((i-(k+1)*16)/16*z[k].b);
    if k in [1..8] then
     Begin
     z[i].r:=z[i].r+20;
     z[i].g:=z[i].g+20;
     z[i].b:=z[i].b+20;
     End;
    End;
 Initpalette(z);
 End;

Procedure GenerateSavFile;
 Var f:TSaveFile;
     a:TSaveBlock;
     i:byte;
 Begin
 a.name:='<EMPTY>';
 a.score:=0;
 assign(f,'Tetris.sav');
 Rewrite(f);
 for i:=1 to 10 do write(f,a);
 Close(f);
 End;



BEGIN
Randomize;
New(p1);
LOADFONT('font.txt');
Intro;
InitSqrs;
If Not Fileexists('Tetris.scr') then generatescr;
If Not Fileexists('Tetris.sav') then generatesavfile;
Fillscr0(0);
Repeat
REs:=menu(mainmenu);
case res of
     1:Game(TRUE);
     2:Game(False);
     3:showhall;
     4:Help;
End;
Until res=5;
ChMod(3);
Dispose(p1);
END.